'use strict';

var onPrint = function onPrint(type, match) {
	return function (window, cb) {
		var called = false,
		    query = void 0,
		    queryFn = void 0;

		var unsubscribe = function unsubscribe() {
			if (queryFn) query.removeListener(queryFn);
			window.removeEventListener(type + 'print', print, false);
		};

		var print = function print() {
			if (called) return;
			called = true;
			cb();
		};

		if (window.matchMedia) {
			queryFn = function queryFn(query) {
				if (query.matches === match) print();
			};
			query = window.matchMedia('print');
			query.addListener(queryFn);
		} else {
			window.addEventListener(type + 'print', print, false);
		}

		return unsubscribe;
	};
};

module.exports = {
	before: onPrint('before', true),
	after: onPrint('after', false),
	onPrint: onPrint
};